
From: Jesper Juhl <juhl-lkml@dif.dk>

Signed-off-by: Jesper Juhl <juhl-lkml@dif.dk>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/drivers/isdn/act2000/act2000_isa.c |    5 ++++-
 1 files changed, 4 insertions(+), 1 deletion(-)

diff -puN drivers/isdn/act2000/act2000_isa.c~check-copy_from_user-return-value-in-act2000_isa_download drivers/isdn/act2000/act2000_isa.c
--- 25/drivers/isdn/act2000/act2000_isa.c~check-copy_from_user-return-value-in-act2000_isa_download	2004-09-20 10:52:11.771503016 -0700
+++ 25-akpm/drivers/isdn/act2000/act2000_isa.c	2004-09-20 10:52:11.775502408 -0700
@@ -434,7 +434,10 @@ act2000_isa_download(act2000_card * card
                 l = (length > 1024) ? 1024 : length;
                 c = 0;
                 b = buf;
-                copy_from_user(buf, p, l);
+                if (copy_from_user(buf, p, l)) {
+                        kfree(buf);
+                        return -EFAULT;
+                }
                 while (c < l) {
                         if (act2000_isa_writeb(card, *b++)) {
                                 printk(KERN_WARNING
_
